﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace Text_Classification
{
    class Tokenizer
    {
		public System.Collections.SortedList Partition(string input)
		{
			Regex r=new Regex("[^a-zA-Z]");			
			input=input.ToLower() ;

			String [] tokens=r.Split(input); 									

			System.Collections.SortedList filter=new System.Collections.SortedList() ;
            StopWordsHandler stopWordsHandler = new StopWordsHandler();
            Stemmer stemmer = new Stemmer();
			for (int i=0; i < tokens.Length ; i++)
			{
				MatchCollection mc=r.Matches(tokens[i]);
                if (mc.Count <= 0 && tokens[i].Trim().Length > 0
                    && !StopWordsHandler.IsStopword(tokens[i]))
                {
                    tokens[i] = stemmer.stemTerm(tokens[i]);
                    if (filter.ContainsKey(tokens[i]))
                    {
                        filter[tokens[i]] = (int)filter[tokens[i]] + 1;
                    }
                    else
                    {
                        filter.Add(tokens[i], 1);
                    }
                }
			}

            return filter;
		}

        public System.Collections.ArrayList NewPartition(string input)
        {
            Regex r = new Regex("[^a-zA-Z]");
            input = input.ToLower();

            String[] tokens = r.Split(input);

            System.Collections.ArrayList filter = new System.Collections.ArrayList();
            //StringBuilder terms = new StringBuilder();
            foreach (string token in tokens)
            {
                filter.Add(token);
            }

            StopWordsHandler stopWordsHandler = new StopWordsHandler();
            System.Collections.ArrayList copyFilter = (System.Collections.ArrayList) filter.Clone();
            foreach (string token in copyFilter)
            {
                MatchCollection mc=r.Matches(token);
                if (!(mc.Count <= 0 && token.Trim().Length > 0
                    && !StopWordsHandler.IsStopword(token)))
                    {
                        filter.Remove(token);
                    }
            }

            System.Collections.ArrayList stemmedTokens = new System.Collections.ArrayList();
            Stemmer stemmer = new Stemmer();
            foreach (string token in filter)
            {
                string tokenStemmed = stemmer.stemTerm(token);
                if (!stemmedTokens.Contains(tokenStemmed))
                    stemmedTokens.Add(tokenStemmed);
            }

            return stemmedTokens;
        }

		public Tokenizer()
		{
		}

    }
}
